#! /bin/bash

#     file     : PaminaIII/bin/TestSuite.bash
#     project  : Pamina III simulation suite
#     author   : Marcus Rickert
#     RCS      : $Id: TestSuite.bash,v 1.1 2005/04/30 10:10:15 mr Exp $
#     purpose  : test the PAMINA distribution archive by compiling the source 
#                code and starting a test setup
#
#     Copyright (C) 2005 :  Marcus Rickert

# TODO:
#

# exit on first error
set -e

# compile the simulation suite...

export TMP_OBJ_DIR=/tmp/mr.test

if [ "$PVM_ROOT" != "" ] 
then
    COM_LIBS="$COM_LIBS PVM"
else
    echo "No PVM_ROOT set -> skipping PVM tests!"
fi

if [ "$MPI_ROOT" != "" ] 
then
    COM_LIBS="$COM_LIBS MPI"
else
    echo "No MPI_ROOT set -> skipping MPI tests!"
fi

for c in $COM_LIBS; do

    export COMMUNICATION=$c

    echo "********************************************************************"
    echo "********************************************************************"
    echo "********************************************************************"
    echo "Compiling suite for communication library $c"
    echo "********************************************************************"
    echo "********************************************************************"
    echo "********************************************************************"
    

    make prepare
    make clean
    make depend
    make

done

# run the test scenario...

for c in $COM_LIBS; do

    export COMMUNICATION=$c

    echo "********************************************************************"
    echo "********************************************************************"
    echo "********************************************************************"
    echo "Running test scenario for communication library $c"
    echo "********************************************************************"
    echo "********************************************************************"
    echo "********************************************************************"
    
    cd scenarios/PaminaScenarioTest

    make prepare
    make clean_stat clean_routes
    make run

    cd ../..

done
