/*      file     : TrafficData/TAlgoEdge.C
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TAlgoEdge.C,v 1.2 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <TEdge.h>
#include <TGridStatLookup.h>

#include "TAlgoEdge.h"

// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***GLOBAL VARIABLES****************************************************************  
// ***LOCAL VARIABLES***************************************************************** 
// ***FUNCTIONS*********************************************************************** 

int
CompareAlgoEdges(TAlgoEdge *Info1, TAlgoEdge *Info2)

{
    if (Info1->GetParallelID() < Info2->GetParallelID())
        return -1;
    else
        if (Info1->GetParallelID() > Info2->GetParallelID())
            return 1;
        else
            return 0;
}

// ***METHODS************************************************************************* 

#ifdef NO_INLINE
#  include "TAlgoEdge.i.C"
#endif

// =================================================================================== 
#define ParentClass TBaseObject
// =================================================================================== 

TAlgoEdge::TAlgoEdge(void)

{
    Edge = 0;
    Lookup = 0; 
    DestAlgoInfo = 0;
}

// =================================================================================== 

TString
TAlgoEdge::GetClassName(void) const

{
    return "TAlgoEdge";
}

// =================================================================================== 

bool
TAlgoEdge::Load(TEdge *theEdge, TInfoID LookupClassInfoID, 
                TAlgoInfo *theOriginAlgoInfo, TAlgoInfo *theDestAlgoInfo)

{
    Edge = theEdge;
    if (LookupClassInfoID != INVALID)
    {
        if ((Lookup = (TGridStatLookup *) Edge->GetInfo(LookupClassInfoID)) == 0)
        {
            Error("Load: cannot load grid stat lookup for %s", 
                  (char *) Edge->GetObjectName());
            return FALSE;
        }    
        OriginAlgoInfo = theOriginAlgoInfo;
        DestAlgoInfo = theDestAlgoInfo;
    }
    return TRUE;
}

// =================================================================================== 
#undef ParentClass
