/*      file     : TrafficData/TIntersectionControl.i.C
        project  : PAMINA III
        authors  : Marcus Rickert
        RCS      : $Id: TIntersectionControl.i.C,v 1.4 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************

#include <TRandom.h>
#include "TPhase.h"

// ***METHODS************************************************************************* 

inline double
TIntersectionControl::GetGreenRatio(int EdgeNr) const

{
    return (1.0 * Phases[EdgeNr]->Const.GreenPhaseLength / 
            (Phases[EdgeNr]->Const.GreenPhaseLength + Phases[EdgeNr]->Const.NonGreenPhaseLength));
}

// =================================================================================== 

inline int
TIntersectionControl::GetNrOfPhases(void) const

{
    return (int) NrOfPhases;
}

// =================================================================================== 

inline bool
TIntersectionControl::IsIncomingSegmentActive(int EdgeNr)

{
    if (Phases[EdgeNr])
        return Phases[EdgeNr]->IsActive();
    else
        return TRUE;
}

// =================================================================================== 

inline bool
TIntersectionControl::IsIncomingVehicleActive(int EdgeNr)

{ 
    if (Phases[EdgeNr])
        return Phases[EdgeNr]->IsActive();
    else
        return TRUE;
}

// =================================================================================== 

