/*      file     : TrafficData/TMultilaneBoundary.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TMultilaneBoundary.h,v 1.6 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TMULTILANEBOUNDARY_H
#define TMULTILANEBOUNDARY_H

// ***INCLUDES************************************************************************ 

#include <CAConfig.h>
#include <TBoundary.h>
#include <TTimeStep.h>

// ***FORWARDS************************************************************************

class TClassInfo;
class TMultilaneGrid;

#include <TVehicle.forward.h>

// ***CLASSES************************************************************************* 

class TMultilaneBoundary : public TBoundary

{
public:

    TMultilaneBoundary(TMultilaneGrid *theDistributedGrid, const TTimeStep &theTimeStep);
    TMultilaneBoundary(TParallelID theParalellID);
    virtual ~TMultilaneBoundary(void);

    static TClassInfo *ClassInfo;

private:

    TTimeStep     TimeStep;
    //  >>> DO NOT SEPERATE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#define TMULTILANEBOUNDARY_LONG 2
    long          NrOfLanes;
    long          BoundaryWidth;
    //  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
    TSite         Sites[MAX_LANES][MAX_BOUNDARY_WIDTH];
    TVehicleList *Vehicles;

    virtual bool
        Assign(void);

    virtual bool
        Decode(TBaseStream *Stream, TTransferInfo *TransferInfo);

    virtual bool
        Encode(TBaseStream *Stream, TTransferInfo *TransferInfo) const;

    virtual TString
    GetClassName(void) const;

    virtual TString
    GetInstanceName(void) const;

    void
    _Init(void);
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
