/*      file     : TrafficData/TSimpleIntersection.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TSimpleIntersection.h,v 1.5 2005/03/25 12:28:52 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TROUTEDINTERSECTION_H
#define TROUTEDINTERSECTION_H

// ***INCLUDES************************************************************************ 

#include "TIntersection.h"

// ***FORWARDS************************************************************************

class TRandom;
class TString;
class TTimeStep;
class TVehicle;

// ***CLASSES************************************************************************* 

class TSimpleIntersection : public TIntersection

{
 public:

    TSimpleIntersection(TParallelID theParallelID = INVALID);
    virtual ~TSimpleIntersection(void);

    virtual bool
    ExecuteSubTimeStep(const TTimeStep &TimeStep);

    static inline TSimpleIntersection *
    GetPtr(TParallelID ID, bool Warn = FALSE);

    virtual bool
    PrepareSubTimeStep(const TTimeStep &TimeStep);

    static TClassInfo *ClassInfo;
    static int ScanRange;
    static int TVelocity;
    
 private:
    
    virtual bool
    Activate(void);

    void
    Block(void);

    bool
    DetectThroughways(void);

    virtual TString
    GetClassName(void) const;

    bool
    MoveToDestinationSegment(TVehicle *Vehicle, int SourceGridNr,
                             long CorLane, long CorOffset, long Vmax);

    bool
    ScanSourceGrid(const TTimeStep &TimeStep, int SourceGridNr);

    TRandom *Random;
    int     *DestGridNrs;
};

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TSimpleIntersection.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
