/*      file     : TrafficData/TSink.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TSink.h,v 1.4 2005/03/25 12:28:52 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TSINK_H
#define TSINK_H

// ***INCLUDES************************************************************************ 

#include <TParallelObject.h>

// ***FORWARDS************************************************************************

class TClassInfo;
class TMultilaneGrid;
class TRoutingStat;
class TTimeStep;
class TVehicle;

// ***CLASSES************************************************************************* 

class TSinkVarData 

{
public:

    TSinkVarData(void);

    //  >>> DO NOT SEPERATE <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#define  TSINK_LONG 2
    long Deletions;
    long RoutesFailed;
    //  >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
};

// ===================================================================================

class TSink : public TParallelObject

{
    friend class TRoutingStat;

public:

    TSink(TParallelID theParallelID);

    bool
    AssignGrid(TMultilaneGrid *theGrid, long theOffset);

    virtual bool
    Decode(TBaseStream *aStream, TTransferInfo *TransferInfo);

    bool
    DestroyVehicle(const TTimeStep &TimeStep, TVehicle *&Vehicle);

    virtual bool
    Encode(TBaseStream *aStream, TTransferInfo *TransferInfo) const;

    bool
    ExecuteSubTimeStep(const TTimeStep &TimeStep);

    void
    VehicleFailed(TVehicle *Vehicle);

    static TClassInfo *ClassInfo;

private:

    virtual TString
    GetClassName(void) const;

    TSinkVarData Var;

    TMultilaneGrid *Grid;
    long            Offset;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
