/*      file     : TrafficData/TVehicle.i.C
        project  : PAMINA III
        authors  : Marcus Rickert
        RCS      : $Id: TVehicle.i.C,v 1.5 2005/03/25 12:28:52 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline void
TVehicle::ActivateTrace(void)

{
    Flags |= V_FLAG_TRACE;
}

// =================================================================================== 

inline long
TVehicle::GetLane(void) const

{
    return Lane;
}

// =================================================================================== 

inline double
TVehicle::GetMaxVelocity(void) const

{
    return MaxVelocity;
}

// =================================================================================== 

inline long
TVehicle::GetOffset(void) const

{
    return Offset;
}

// =================================================================================== 

inline TRouteplan *
TVehicle::GetRouteplan(void)

{
    return Routeplan;
}

// ===================================================================================

inline void
TVehicle::SetCurrentVelocityInCAUnits(long theCurrentVelocity)

{
    CurrentVelocity = CA_VELOCITY_TO_REAL_VELOCITY(theCurrentVelocity);
}

// ===================================================================================

inline void
TVehicle::SetCurrentVelocity(double theCurrentVelocity)

{
    CurrentVelocity = theCurrentVelocity;
}

// =================================================================================== 

inline void
TVehicle::SetLane(long theLane)
    
{
    Lane = theLane;
}

// ===================================================================================

inline void
TVehicle::SetMaxVelocity(double theMaxVelocity)

{
    MaxVelocity = theMaxVelocity;
}

// ===================================================================================

inline void
TVehicle::SetMaxVelocityInCAUnits(long theMaxVelocity)

{
    MaxVelocity = CA_VELOCITY_TO_REAL_VELOCITY(theMaxVelocity);
}

// =================================================================================== 

inline void
TVehicle::SetOffset(long theOffset)

{
    Offset = theOffset;
}

// =================================================================================== 

inline void
TVehicle::SetRouteplan(TRouteplan *theRouteplan)

{
    if (theRouteplan)
        SetBaseFlags(V_FLAG_ROUTEPLAN);
    else
        ResetBaseFlags(V_FLAG_ROUTEPLAN);
    Routeplan = theRouteplan;
}

// =================================================================================== 

inline bool
TVehicle::TraceActive(void) const

{
    return Flags & V_FLAG_TRACE;
}

// ===================================================================================

