/*      file     : common/TConfigHandler.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TConfigHandler.h,v 1.5 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TCONFIGHANDLER_H
#define TCONFIGHANDLER_H

// ***INCLUDES************************************************************************ 

#include <stdio.h>
#include <TDLList.h>

// ***DEFINES*************************************************************************

#define ActivateDeactivate(boolean) ((boolean)? "activate":"deactivate")

// ***FORWARDS************************************************************************

class TConfig;

// ***CLASSES************************************************************************* 

/**
  */

class TConfigHandler : public TDLNodePrimitive

{
friend class TConfig;

public:

    TConfigHandler(void);

    const TConfig *
        GetConfig(void) const;
    virtual int
        GetConfigEntryCount(void) const = 0;
    virtual bool
        HandleConfigItem(int ID, const char *Name, const char *Value) = 0;
    virtual void
        WriteSignature(void) const;
    void
        RegisterTokenArray(int &Index, char **Tokens, 
                           int Count, char **NewTokens);
    virtual void
        RegisterTokens(int &Index, char **Tokens) = 0;
    void
        SetConfig(TConfig *theConfig);
    void
        SignatureHeader(const char *header) const;
    void
        SignatureLine(const char *Format, ...) const;

protected:

    int            ConfigIDBase;
    const TConfig *Config;
};

// ***TYPES*************************************************************************** 

typedef TDLList < TConfigHandler > TConfigHandlerList;
typedef TDLListEnum < TConfigHandler > TConfigHandlerEnum;

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
