/*      file     : common/TEnumerator.i.C
        project  : General Toolbox
        authors  : Marcus Rickert
        RCS      : $Id: TEnumerator.i.C,v 1.3 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include "TContainer.h"

// ***METHODS************************************************************************* 

inline
TEnumeratorPrimitive::operator TBaseObject * (void)

{
    return GetCurrent();
}

// =================================================================================== 

inline TBaseObject *
TEnumeratorPrimitive::operator -> (void)

{
    return GetCurrent();
}

// =================================================================================== 

inline void
TEnumeratorPrimitive::operator ++ (int)

{
    Container->MoveForward(this);
}

// ===================================================================================

inline long
TEnumeratorPrimitive::operator () (void)

{
    return Container->WhileEnumeration(this);
}

// =================================================================================== 

inline void
TEnumeratorPrimitive::Enumerate(void)

{
    Container->Enumerate(this);
}

// ===================================================================================

inline TBaseObject *
TEnumeratorPrimitive::GetCurrent(void)

{
    return Container->GetCurrent(this)->GetInstancePtr();
}

// ===================================================================================

inline TBaseObject *
TEnumeratorPrimitive::GetCurrentContainerEntry(void)

{
    return Container->GetCurrent(this);
}

// =================================================================================== 

inline TBaseObject *
TEnumeratorPrimitive::GetDataPtr(void)

{
    return DataPtr;
}

// ===================================================================================

inline long
TEnumeratorPrimitive::GetIndex(void)

{
    return Index;
}

// ===================================================================================

inline void
TEnumeratorPrimitive::SetDataPtr(TBaseObject *theDataPtr)

{
    DataPtr = theDataPtr;
}

// ===================================================================================

inline void
TEnumeratorPrimitive::SetIndex(long theIndex)

{
    Index = theIndex;
}

// ===================================================================================




