/*      file     : common/TEnvironment.i.C
        project  : General Toolbox
        authors  : Marcus Rickert
        RCS      : $Id: TEnvironment.i.C,v 1.10 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline TString
TEnvironment::GetApplicationFilename(const char *Path) const

{
    return GetFilename(AppBaseDir, Path);
}

// =================================================================================== 

inline int
TEnvironment::argc(void) const

{
    return my_argc;
}

// =================================================================================== 

inline char **
TEnvironment::argv(void) const

{
    return my_argv;
}

// =================================================================================== 

inline int *
TEnvironment::pargc(void)

{
    return &my_argc;
}

// =================================================================================== 

inline char ***
TEnvironment::pargv(void)

{
    return &my_argv;
}

// =================================================================================== 

inline TConfig *
TEnvironment::GetConfig(void) const

{
    return Config;
}

// =================================================================================== 

inline TConfiguration *
TEnvironment::GetConfiguration(void) const

{
    return Configuration;
}

// =================================================================================== 

inline const char *
TEnvironment::GetExecutable(void) const

{
    return Executable;
}

// =================================================================================== 

inline TErrorStatus
TEnvironment::GetExitCode(void) const

{
    return ExitCode;
}

// =================================================================================== 

TString
TEnvironment::GetHomeFilename(const char *Path) const

{
    return GetFilename(HomeDir, Path);
}

// =================================================================================== 

inline TLocalID 
TEnvironment::GetLocalID(void) const

{
    return LocalID;
}

// =================================================================================== 

inline void
TEnvironment::SetArchitecture(const char *theArchitecture)

{
    Architecture = theArchitecture;
}

// =================================================================================== 

inline void
TEnvironment::SetExitCode(TErrorStatus theExitCode)

{
    if (ExitCode == Status_OK)
        ExitCode = theExitCode;
}

// =================================================================================== 

inline void
TEnvironment::SetHostName(const char *theHostName)

{
    HostName = theHostName;
}

// =================================================================================== 

inline void
TEnvironment::SetLocalID(TLocalID theLocalID) 

{
    LocalID = theLocalID;    
}

// =================================================================================== 

inline TTimer *
TEnvironment::GetOverallTimer(void) 

{
    return OverallTimer;
}

// =================================================================================== 

inline void
TEnvironment::SetPrintPrefix(const char *thePrefix)

{
    PrintPrefix = thePrefix;
    _PrintPrefix = PrintPrefix();
}

// =================================================================================== 

inline void
TEnvironment::SetProcessName(const char *theProcessName)

{
    ProcessName = theProcessName;
}

// =================================================================================== 

inline void
TEnvironment::SetRunName(const char *theRunName)

{
    RunName = theRunName;
}

// =================================================================================== 

inline void
TEnvironment::SetWorkDir(const char *theWorkDir)

{
    WorkDir = theWorkDir;
}

// =================================================================================== 
