/*      file     : common/TListEnum.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TListEnum.C,v 1.5 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass
// =================================================================================== 

TDLListEnumPrimitive::TDLListEnumPrimitive(void)

{
    CurrentList = 0;
    PreviousEnum = 0;
}

/* =================================================================================== */

TDLListEnumPrimitive::~TDLListEnumPrimitive(void)

{
    if (CurrentList)
        CurrentList->SetCurrentEnum(PreviousEnum);
}

/* =================================================================================== */

TDLListEnumPrimitive::operator const TListNodePrimitive * () const

{
    return Current;
}

/* =================================================================================== */

TDLListEnumPrimitive::operator TListNodePrimitive * () const

{
    return (TListNodePrimitive * ) Current;
}

/* =================================================================================== */

TDLListEnumPrimitive::operator TListNodePrimitive const & () const

{
    return *Current;
}

/* =================================================================================== */

TDLListEnumPrimitive::operator TListNodePrimitive & () const

{
    return (TListNodePrimitive &) *Current;
}

/* =================================================================================== */

TListNodePrimitive *
TDLListEnumPrimitive::operator -> ()

{
    return (TListNodePrimitive *) Current;
}

/* =================================================================================== */

TDLListEnumPrimitive::operator long () const

{
    return Current != Head;
}

/* =================================================================================== */

void
TDLListEnumPrimitive::operator = (TListNodePrimitive *Node)

{
    Current = Node;
    Current->GetListIndex(CurrentList, CurrentIndex);
    NextIndex = Current->GetNextIndex(CurrentIndex);
    Next = Current->GetNext(CurrentIndex);
}

/* =================================================================================== */

void
TDLListEnumPrimitive::UpdateUponDelete(const TListNodePrimitive *Previous, int PreviousIndex)

{
    if (Current->GetPrev(CurrentIndex) == Previous)
    {
        Current = Previous;
        CurrentIndex = PreviousIndex;
    }
    Next = Current->GetNext(CurrentIndex);
    NextIndex = Current->GetNextIndex(CurrentIndex);
    if (PreviousEnum)
    {
        //      fprintf(stderr, "recursive UpdateUponDelete\n");
        PreviousEnum->UpdateUponDelete(Previous, PreviousIndex);
    }
}

/* =================================================================================== */

void
TDLListEnumPrimitive::UnlinkList(void)

{
    CurrentList = 0;
}

/* =================================================================================== */

void
TDLListEnumPrimitive::_WalksBackwardThrough(TDLListPrimitive &theList)

{
    if (CurrentList)
        CurrentList->SetCurrentEnum(0);
    theList.SetCurrentEnum(this);
    CurrentList = & theList;
    Current = Head = theList.GetHead();
    Current->GetListIndex(&theList, CurrentIndex);
    NextIndex = Current->GetPrevIndex(CurrentIndex);
    Next = Current->GetPrev(CurrentIndex);
    operator--(1);
}

/* =================================================================================== */

void
TDLListEnumPrimitive::_WalksForwardThrough(TDLListPrimitive &theList)

{
    if (CurrentList)
        CurrentList->SetCurrentEnum(0);
    if (theList.GetNrOfElements() > 0)
    {
        if (PreviousEnum == 0)
            PreviousEnum = theList.GetCurrentEnum();
        theList.SetCurrentEnum(this);
        CurrentList = & theList;
        Current = Head = theList.GetHead();
        Current->GetListIndex(&theList, CurrentIndex);
        NextIndex = Current->GetNextIndex(CurrentIndex);
        Next = Current->GetNext(CurrentIndex);
        operator++(1);
    }
    else
        Current = Head = theList.GetHead();     
}


// =================================================================================== 
#undef ParentClass
