/*      file     : common/TListNode.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TListNode.C,v 1.3 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// =================================================================================== 
#define ParentClass
// ===================================================================================

/* LeftLink links the object to its future left neighbour pointed to by aNode */

bool
TListNodePrimitive::LeftLink(TDLListPrimitive *theList, const TListNodePrimitive *aNode,
                           bool Unique) const

{
    int MyIndex;
    int itsIndex;
    int itsRightIndex;

    if (!aNode->GetListIndex(theList, itsIndex))
    {
        Debug.Message("TListNodePrimitive::LeftLink: list index not found "
                      "(NrOfElements:%ld)!", theList->GetNrOfElements());
        return FALSE;
    }
    itsRightIndex = aNode->GetNextIndex(itsIndex);
    if (GetListIndex(theList, MyIndex))
        return !Unique;
    if (!GetFreeReferenceIndex(MyIndex))
        return FALSE;

    /* link the object to the future right neighbour */
    
    SetNext(MyIndex, aNode->GetNext(itsIndex), itsRightIndex);

    /* link the object to its future left neighbour */
    
    SetPrev(MyIndex, aNode, GetNext(MyIndex)->GetPrevIndex(itsRightIndex));

    /* link the future left neighbour to the object */
    
    aNode->SetNext(itsIndex, this, MyIndex);

    /* link the future right neighbour to the object */
    
    GetNext(MyIndex)->SetPrev(itsRightIndex, this, MyIndex);

    SetList(MyIndex, theList);
    theList->NrOfElements++;
    return TRUE;
}

/* =================================================================================== */

bool
TListNodePrimitive::Unlink(TDLListPrimitive *aList) const

{
    int  Index;

    if (!GetListIndex(aList, Index))
        return FALSE;
    GetPrev(Index)->SetNext(GetPrevIndex(Index), GetNext(Index), GetNextIndex(Index));
    GetNext(Index)->SetPrev(GetNextIndex(Index), GetPrev(Index), GetPrevIndex(Index));    
    aList->UpdateCurrentEnum(GetPrev(Index), GetPrevIndex(Index));
    FreeReference(Index);
    aList->NrOfElements--;
    return TRUE;
}

// =================================================================================== 
#undef ParentClass
