/*      file     : common/TSLList.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TSLList.C,v 1.4 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// =================================================================================== 
#define ParentClass TListNodePrimitive
// =================================================================================== 

TSLNodePrimitive::TSLNodePrimitive(void)

{
    InitListReference(Ref);
}

// =================================================================================== 

TSLNodePrimitive::~TSLNodePrimitive(void)

{
    UnlinkAll();
}

/* =================================================================================== */

void
TSLNodePrimitive::FreeReference(int Index) const

{
    SetList(Index, 0);
}

/* =================================================================================== */

const TListNodePrimitive *
TSLNodePrimitive::GetNext(int) const

{
    return Ref.Next;
}

/* =================================================================================== */
 
int
TSLNodePrimitive::GetNextIndex(int) const

{
    return Ref.NextIndex;
}

/* =================================================================================== */

const TListNodePrimitive *
TSLNodePrimitive::GetPrev(int) const

{
    return Ref.Prev;
}

/* =================================================================================== */

int
TSLNodePrimitive::GetPrevIndex(int) const

{
    return MutableAccess(TSLNodePrimitive, Ref).PrevIndex;
}

/* =================================================================================== */

bool
TSLNodePrimitive::GetFreeReferenceIndex(int &Index) const

{
    if (Ref.List != 0)
    {
        Debug.Message("TSLNodePrimitive::GetFreeRefrenceIndex: cannot add reference!");
        return FALSE;
    }
    Index = 0;
    return TRUE;    
}

/* =================================================================================== */

bool
TSLNodePrimitive::GetListIndex(const TDLListPrimitive *theList, int &Index) const

{    
    if (theList == Ref.List)
    {
        Index = 0;
        return TRUE;
    }
    return FALSE;
}

/* =================================================================================== */

void
TSLNodePrimitive::SetList(int, TDLListPrimitive *theList) const

{
    MutableAccess(TSLNodePrimitive, Ref.List) = theList;
}

/* =================================================================================== */

void
TSLNodePrimitive::SetNext(int, const TListNodePrimitive *NextNode, int NextIndex) const

{
    
    MutableAccess(TSLNodePrimitive, Ref.Next) = NextNode;
    MutableAccess(TSLNodePrimitive, Ref.NextIndex) = NextIndex;
}

/* =================================================================================== */

void
TSLNodePrimitive::SetPrev(int, const TListNodePrimitive *PrevNode, int PrevIndex) const

{
    MutableAccess(TSLNodePrimitive, Ref).Prev = PrevNode;
    MutableAccess(TSLNodePrimitive, Ref).PrevIndex = PrevIndex;
}

/* =================================================================================== */

bool
TSLNodePrimitive::UnlinkAll(void)

{
    if (Ref.List)
        if (!Unlink(Ref.List))
            return FALSE;
    return TRUE;
}


// =================================================================================== 
#undef ParentClass
