/*      file     : common/TStringContainerEntry.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TStringContainerEntry.C,v 1.3 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include "TStringContainerEntry.h"

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass TContainerEntry
// =================================================================================== 

TStringContainerEntryPrimitive::TStringContainerEntryPrimitive(const char *theString, 
                                                               TBaseObject *theDataPtr) :

ParentClass(theDataPtr),
String(theString)

{
}

// =================================================================================== 

int
TStringContainerEntryPrimitive::Compare(TBaseObject *OtherObject, int CompareCode) const

{
    TStringContainerEntryPrimitive *OtherEntry =
        (TStringContainerEntryPrimitive *) OtherObject;

    return StrCmp(String, OtherEntry->GetString(), CompareCode);
}

// =================================================================================== 

TString
TStringContainerEntryPrimitive::GetClassName(void) const

{
    return "TStringContainerEntry";
}

// =================================================================================== 

TString
TStringContainerEntryPrimitive::GetInstanceName(void) const

{
    char Buffer[512];

    sprintf(Buffer, "key ('%s') %s", String(), (char *) ParentClass::GetInstanceName());
    return Buffer;
}

// =================================================================================== 
#undef ParentClass
