/*      file     : common/TStringTable.t.C
        project  : Formale Sprachen
        authors  : Marcus Rickert
        RCS      : $Id: TStringTable.t.C,v 1.3 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// =================================================================================== 
#define ParentClass TBaseObject
// =================================================================================== 

template <class T>
TStringTableEntry< T >::TStringTableEntry (void)

{
}

// ===================================================================================

template <class T>
TStringTableEntry< T >::TStringTableEntry(const char *aString, T AnItem) :

Key(aString)

{
    Item = AnItem;
}

// ===================================================================================
    
template <class T>
TStringTableEntry< T >::TStringTableEntry(const char *aString) :

Key(aString)

{
}

// ===================================================================================

template <class T>
int
TStringTableEntry< T >::Compare(TBaseObject *OtherObject, int CompareCode) const

{
    TStringTableEntry< T > *OtherEntry = (TStringTableEntry< T > *) OtherObject;

    switch (CompareCode)
    {
    case STRCMP_NO_PREFIX:
    case STRCMP_S1_PREFIX:
    case STRCMP_S2_PREFIX:
        return StrCmp(Key, OtherEntry->GetKey(), CompareCode);

    default:
        return ParentClass::Compare(OtherObject, CompareCode);
    }                       
}


// =================================================================================== 

template < class T >
inline const char *
TStringTableEntry< T >::GetKey(void) const

{
    return Key();
}

// =================================================================================== 

template < class T >
inline T
TStringTableEntry< T >::GetItem(void) const

{
    return Item;
}

// ===================================================================================
#undef ParentClass
#define ParentClass TABTreeEnum< TStringTableEntry< DataType > >
// ===================================================================================

template < class DataType >
DataType
TStringTableEnum< DataType >::operator -> (void)

{
    TStringTableEntry< DataType> *FindEntry;

    if ((FindEntry = (TStringTableEntry< DataType > *) ParentClass::GetCurrent()))
        return FindEntry->GetItem();
    else
        return (DataType) 0;
}


// ===================================================================================

template < class DataType >
TStringTableEnum< DataType >::operator DataType (void)

{
    TStringTableEntry< DataType> *FindEntry;

    if ((FindEntry = (TStringTableEntry< DataType > *) ParentClass::GetCurrent()))
        return FindEntry->GetItem();
    else
        return (DataType) 0;
}


// ===================================================================================

template < class DataType >
void
TStringTableEnum< DataType >::Select(TABTreePrimitive &aTree, const char *aString,
                                     int CompareCode)

{
    if (aString)
    {
        TStringTableEntry< DataType > Entry(aString);

        ParentClass::Select(aTree, &Entry, CompareCode);
    }
    else
        ParentClass::Select(aTree, 0, CompareCode);
}

// ===================================================================================
#undef ParentClass
#define ParentClass TABTree< TStringTableEntry< DataType > >
// ===================================================================================

template < class DataType >
DataType
TStringTable< DataType >::Find(const char *aString, int CompareCode)

{
    TStringTableEntry< DataType> *FindEntry;
    bool                      Found = FALSE;

    if ((FindEntry = (TStringTableEntry< DataType > *) 
        ParentClass::Find(TStringTableEntry< DataType >(aString), Found, CompareCode)))
        return FindEntry->GetItem();
    else
        return (DataType) 0;
}

// =================================================================================== 
#undef ParentClass
