/*      file     : graphx/showFont.c
        project  : graphical toolbox
        author   : Michael Olesen
        comments : simple classes for using X11
        RCS      : $Id: showfont.c,v 1.2 2005/03/25 11:06:10 mr Exp $
*/

#include <graphx.h>

void main(int argc,char **argv) {
  int m;
  grWindow *theWindow;

  if (argc != 2) {
    fprintf(stderr,"Usage: showfont font.\n\a");
    exit(1);
  }
  
  theWindow = grCreateWindow("showfont ver 1.0 \xa9 /Nadel\x40jourgensen.la-villita.nm",300,300);
  grSetXaxis(theWindow,-1,16);
  grSetYaxis(theWindow,-1,18);

  if (theWindow == NULL) {
    fprintf(stderr,"Unable to create graphics window.\n");
    exit(1);
  }
  
  grLoadFontName(theWindow,argv[1]);
  
  grSetHorizontalTextAlignment(theWindow,GrCenterAlign);
  grSetVerticalTextAlignment(theWindow,GrCenterAlign);
  
  grX11SetSpeed(theWindow,GrFast);

  grX11SetCursor(theWindow,XC_iron_cross);
    
  grX11WaitUntilExposed(theWindow);

  grClearScreen(theWindow,theWindow->noColors-1);

  for (m = 0;m < 16;m++)
    grUsrDrawLine(theWindow,-0.1,m,16,m,0);
  
  for (m = 0;m < 16;m++)
    grUsrDrawLine(theWindow,m,-0.1,m,16,0);
    
  for (m = 0;m < 16;m++) {
    if (m < 10) {
      grUsrDrawChar(theWindow,-0.5,m+0.5,(char)('0'+m),0);
      grUsrDrawChar(theWindow,m+0.5,-0.5,(char)('0'+m),0);
    }
    else {
      grUsrDrawChar(theWindow,-0.5,m+0.5,(char)('A'+m-10),0);
      grUsrDrawChar(theWindow,m+0.5,-0.5,(char)('A'+m-10),0);
    }
  }
  
  grUsrDrawString(theWindow,7.5,17,argv[1],0);
  
  if (!grLoadFontName(theWindow,argv[1])) {
    fprintf(stderr,"Unable to load font %s.\n\a",argv[1]);
    exit(1);
  }
  
  for (m = 0;m < 256;m++) grUsrDrawChar(theWindow,m%16+0.5,m/16+0.5,(char)m,0);
  
  while(!grX11CheckMaskEvent(theWindow,ButtonReleaseMask));
}
