/*      file     : mpi/MPIConfig.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: MPIConfig.h,v 1.4 2005/05/01 14:57:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef MPICONFIG_H
#define MPICONFIG_H

// ***DEFINES************************************************************************* 

/** @name Configuration Group MPI
  The configuration group [MPI] understands the following names:
  \begin{itemize}
  \item {\bf MaxBuffer=N;} Use {\tt N} message buffers.
  \item {\bf BufferSize=N;} Set buffer size to {\tt N} bytes.
  \end{itemize}
  */

#define MPI_GROUP               "MPI"
#define MPI_NAME_MAXBUFFER      "MaxBuffer"
#define MPI_NAME_BUFFERSIZE     "BufferSize"

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
