/*      file     : mpi/TMPIBuffer.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TMPIBuffer.i.C,v 1.4 2005/05/01 14:57:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline bool
TMPIBuffer::Check(int DesiredSize) const

{
    if (DesiredSize > Size-Position)
    {
        Warning("potential buffer overflow by %d bytes", DesiredSize - (Size-Position));
        return FALSE;
    }
    return TRUE;
}

// =================================================================================== 

inline char *
TMPIBuffer::GetBase(void) const

{    
    return Base;
}

// =================================================================================== 

inline int &
TMPIBuffer::GetPosition(void)

{
    return Position;
}

// =================================================================================== 

inline long
TMPIBuffer::GetSize(void) const

{
    return Size;
}

// =================================================================================== 
