/*      file     : mpi/TMPIMessage.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TMPIMessage.h,v 1.8 2005/05/01 14:57:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TMPIMESSAGE_H
#define TMPIMESSAGE_H

// ***INCLUDES************************************************************************ 

#include <TBaseMessage.h>

// ***FORWARDS************************************************************************

class TDestination;
class TMPIBuffer;

// ***CLASSES************************************************************************* 

/** Contains the MPI interface for messages.
*/

class TMPIMessage : public TBaseMessage

{
public:

    TMPIMessage(TCommunicationControl *theControl, TMPIBuffer *theBuffer, 
                TCPNID theSender);
    TMPIMessage(TCommunicationControl *theControl, TMPIBuffer *theBuffer,       
                TMessageID theID, TCPNID theSender, 
                TDestination *Destination, TMessageTag theTag,
                TMessageType theType, TMessageFlags theFlags);
    virtual ~TMPIMessage(void);


#include "TMPIMessage.Headers.h"

private:

    virtual bool
        BeginSend(void);
    virtual bool
        EndSend(void);
    TString
        GetClassName(void) const;
    virtual TString
        GetInstanceName(void) const;
    void
        _Init(void);
    bool
        Select(void);

    TMPIBuffer *Buffer;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
