/*      file     : parallel/TEventHandler.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TEventHandler.C,v 1.3 2005/03/25 11:06:20 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <stdio.h>

#include <ParallelTypes.h>
#include <TEventHandler.h>

// ***METHODS************************************************************************* 

TEventHandlerPrimitive::TEventHandlerPrimitive(TEventHandlerPrimitive *theRelayHandler)

{
    RelayHandler = theRelayHandler;
    HandlerObjects = 0;
}

// =================================================================================== 

TEventHandlerPrimitive::~TEventHandlerPrimitive(void)

{
    DeleteObjectArray(HandlerObjects);
}

// =================================================================================== 

bool
TEventHandlerPrimitive::RegisterEventHandler(TEventID EventID, 
                                             TEventHandlerPrimitive *theHandler)

{
    if (HandlerObjects == 0)
    {
        int i;
            
        HandlerObjects = new TEventHandlerPrimitive *[MAX_EVENTS];
        for (i = 0; i < MAX_EVENTS; i++)
            HandlerObjects[i] = 0;
    }
    if (HandlerObjects[EventID])
    {
        Error("RegisterEventHandler: event ID %ld already registered", EventID);
        return FALSE;
    }
    HandlerObjects[EventID] = theHandler;
    return TRUE;
}

// =================================================================================== 

