/*      file     : parallel/TMemoryMessageControl.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TMemoryMessageControl.h,v 1.7 2005/03/25 11:06:20 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TMEMORYMESSAGECONTROL_H
#define TMEMORYMESSAGECONTROL_H

// ***INCLUDES************************************************************************ 

#include <TBaseObject.h>
#include <TCommunicationControl.h>

// ***FORWARDS************************************************************************

class TDestination;

// ***CLASSES************************************************************************* 

class TMemoryMessageControl : public TCommunicationControl

{
public:

    TMemoryMessageControl(void);
    virtual ~TMemoryMessageControl(void);

private:

    virtual TBaseMessage *
        GetNewMessage(TMessageID theID, TCPNID theSender, 
                      TDestination *theDestination, TMessageTag theTag, 
                      TMessageType theType, TMessageFlags theFlags);
    virtual TString
        GetClassName(void) const;
    void
        _Init(void);
    virtual bool
        MessageIsPending(void) const;
    virtual bool
        ReceiveMessage(TBaseMessage *&theMessage, long TimeOut);
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
