/*      file     : parallel/TTopologyUser.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TTopologyUser.C,v 1.3 2005/03/25 11:06:21 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include "TTopologyUser.h"

// ***METHODS************************************************************************* 

TTopologyUser::TTopologyUser(void)

{
    Mutable = new TTopologyUserMutable;
    Mutable->TopologyCurrent = FALSE;
}

// =================================================================================== 

TTopologyUser::~TTopologyUser(void)

{
    DeleteObject(Mutable);
}

// =================================================================================== 

void
TTopologyUser::ActionBeforeAddCPN(const TCPNInfo *)

{
}

// =================================================================================== 

void
TTopologyUser::ActionAfterAddCPN(const TCPNInfo *)

{
    MarkTopologyModified();
}

// =================================================================================== 

void
TTopologyUser::ActionBeforeRemoveCPN(const TCPNInfo *)

{    
}

// =================================================================================== 

void
TTopologyUser::ActionAfterRemoveCPN(const TCPNInfo *)

{
    MarkTopologyModified();    
}

// =================================================================================== 

void
TTopologyUser::MarkTopologyCurrent(void) const

{
    Mutable->TopologyCurrent = TRUE;
}

// =================================================================================== 

bool
TTopologyUser::MarkTopologyModified(void)

{
    Mutable->TopologyCurrent = FALSE;
    return TRUE;
}

// ===================================================================================

bool
TTopologyUser::IsTopologyCurrent(void) const

{
    return Mutable->TopologyCurrent;
}

// ===================================================================================

