/*      file     : parbalance/TMigrationContext.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TMigrationContext.h,v 1.3 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TMIGRATIONCONTEXT_H
#define TMIGRATIONCONTEXT_H

// ***INCLUDES************************************************************************ 

#include <TBaseObject.h>
#include <TNode.h>
#include <TCPNInfo.h>

// ***FORWARDS************************************************************************
// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***CLASSES************************************************************************* 

class TMigrationContext : public TBaseObject

{
public:

    TMigrationContext(int theInitialNrOfBoundaries,
                      double theRemainingTransferLoad);

    TMigrationContext &
    operator += (TMigrationContext &otherC);

    void
    Reset(void);

    TNodeList    BoundaryNodes;
    int          InitialNrOfBoundaries;    
    TCPNInfoList CPNInfos;
    TNodeList    Nodes;
    double       Load;    
    double       RemainingTransferLoad;
};

// ***EXTERNALS*********************************************************************** 
// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#endif
// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
