/*      file     : parstat/TSamplingDescription.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TSamplingDescription.i.C,v 1.7 2005/03/25 11:08:01 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline TCPNID
TSamplingDescription::GetDestination(void) const

{
    return Destination;
}

// =================================================================================== 

inline TCPNInfoList *
TSamplingDescription::GetDestList(void) const

{
    return DestList;
}

// =================================================================================== 

inline const TRectangle &
TSamplingDescription::GetFrame(void) const

{
    return Frame;
}

// =================================================================================== 

inline TStatObjectList *
TSamplingDescription::GetObjectList(void) 

{
    return &ObjectList;
}

// =================================================================================== 

inline TClassID
TSamplingDescription::GetStatObjectClassID(void) const

{
    return StatObjectClassID;
}

// =================================================================================== 

inline TTimeStep &
TSamplingDescription::GetTimeStep(void)

{
    return TimeStep;
}

// =================================================================================== 

inline bool
TSamplingDescription::IsAggregationStat(void) const

{
    return (StatFlags & SF_AGGREGATE) != 0;
}

// =================================================================================== 

inline bool
TSamplingDescription::IsMergeStat(void) const

{
    return (StatFlags & SF_MERGE) != 0;
}

// =================================================================================== 

inline bool
TSamplingDescription::IsNeighborStat(void) const

{
    return (StatFlags & SF_NEIGHBORS) != 0;
}

// =================================================================================== 

inline bool
TSamplingDescription::NeedsCollecting(const TTimeStep &CurrentTimeStep) const

{
    return (((long) CurrentTimeStep - (long) Duration.GetStart()) % CollectInterval == 0 AND
            CurrentTimeStep.GetSubStep() == SubTimeStep);
}

// =================================================================================== 

inline bool
TSamplingDescription::NeedsReset(void) const

{
    return SampleInterval != INVALID;
}

// =================================================================================== 

inline bool
TSamplingDescription::NeedsSampling(const TTimeStep &CurrentTimeStep) const

{
    return (SampleInterval != INVALID AND
            ((long) CurrentTimeStep - (long) Duration.GetStart()) % SampleInterval == 0 AND
            CurrentTimeStep.GetSubStep() == SubTimeStep);
}

// =================================================================================== 

inline void
TSamplingDescription::SetDestList(TCPNInfoList *theDestList)

{
    DestList = theDestList;
}

// =================================================================================== 

inline void
TSamplingDescription::SetDuration(TDuration &theDuration)

{
    Duration = theDuration;
}

// =================================================================================== 

inline void
TSamplingDescription::SetFrame(const TRectangle &theFrame)

{
    Frame = theFrame;
}

// =================================================================================== 

inline void
TSamplingDescription::SetCollectInterval(int theCollectInterval)

{
    CollectInterval = theCollectInterval;
}

// =================================================================================== 

inline void
TSamplingDescription::SetSampleInterval(int theSampleInterval)

{
    SampleInterval = theSampleInterval;
}

// =================================================================================== 

inline void
TSamplingDescription::SetTimeStep(const TTimeStep &theTimeStep)

{
    TimeStep = theTimeStep;
}

// =================================================================================== 
