/*      file     : parstat/TTimeLookup.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TTimeLookup.h,v 1.5 2005/03/25 11:08:01 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TTIMELOOKUP_H
#define TTIMELOOKUP_H

// ***INCLUDES************************************************************************ 

#include <TArray.h>
#include <TStatObject.h>

// ***FORWARDS************************************************************************
// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***CLASSES************************************************************************* 

class TTimeLookup : public TParallelObject

{
public:

    TTimeLookup(TClassInfo *ClassInfo, TParallelID theParalellID);
    virtual ~TTimeLookup(void);

    bool
    Get(long TimeStep, TStatObject *&First, double &FirstWeight,
        TStatObject *&Second, double &SecondWeight);
    
    bool
    GetLatest(TStatObject *&Latest);
    
    bool
    Put(TStatObject *theEntry, bool Add = FALSE);
    
private:

    TStatObject             *Default;
    TArray< TStatObject * >  Entries;
    int                      MaxEntries;
};

// ***EXTERNALS*********************************************************************** 
// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#endif
// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
