/*      file     : partools/TLocationInfo.C
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TLocationInfo.C,v 1.7 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <stdio.h>

#include <TBaseStream.h>
#include "TTransferInfo.h"
#include "TClassInfo.h"

#include "TLocationInfo.h"

// ***GLOBAL VARIABLES****************************************************************  

TClassInfo *TLocationInfo::ClassInfo = 0;
TLocation   NullLocation;

// ***METHODS************************************************************************* 

#ifdef NO_INLINE
#  include "TLocationInfo.i.C"
#endif

// =================================================================================== 
#define ParentClass TParallelObject
// =================================================================================== 

TLocationInfo::TLocationInfo(TClassInfo *theClassInfo, TParallelID theParallelID) :

ParentClass(theClassInfo, theParallelID)

{    
}

// =================================================================================== 

TLocationInfo::~TLocationInfo(void)

{
}

// =================================================================================== 

bool
TLocationInfo::Decode(TBaseStream *Stream, TTransferInfo *TransferInfo)

{
    if (!ParentClass::Decode(Stream, TransferInfo))
        return FALSE;
    if (TransferInfo->TransferMode == TM_ConstData)
        return Location.Decode(*Stream);
    else
        return TRUE;
}

// =================================================================================== 

bool
TLocationInfo::Encode(TBaseStream *Stream, TTransferInfo *TransferInfo) const

{
    if (!ParentClass::Encode(Stream, TransferInfo))
        return FALSE;
    if (TransferInfo->TransferMode == TM_ConstData)
        return Location.Encode(*Stream);
    else
        return TRUE;
}

// =================================================================================== 

TString
TLocationInfo::GetClassName(void) const

{
    return "TLocationInfo";
}

// =================================================================================== 

TString
TLocationInfo::GetInstanceName(void) const

{
    return Location.GetInstanceName();
}

// =================================================================================== 
#undef ParentClass
