/*      file     : partools/TTimeStep.i.C
        project  : Parallel Toolbox 2.x
        authors  : Marcus Rickert
        RCS      : $Id: TTimeStep.i.C,v 1.6 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

long
TTimeStep::operator = (long theTimeStep)

{
    TimeStep = theTimeStep;
    SubTimeStep = 0;
    return TimeStep;
}

// ===================================================================================

inline 
TTimeStep::operator long (void) const

{
    return TimeStep;
}


// ===================================================================================

inline bool
TTimeStep::operator == (const TTimeStep &aTimeStep) const

{
    return (TimeStep == aTimeStep.TimeStep AND
            SubTimeStep == aTimeStep.SubTimeStep);
}

// ===================================================================================

inline long
TTimeStep::operator - (const TTimeStep &aTimeStep) const

{
    return GetLinear() - aTimeStep.GetLinear();
}

// ===================================================================================

inline TTimeStep
TTimeStep::operator + (long Delta) const

{
    return TTimeStep(TimeStep + Delta, SubTimeStep);
}

// ===================================================================================

inline void
TTimeStep::operator += (long Delta)

{
    TimeStep += Delta;
}

// ===================================================================================

inline bool
TTimeStep::operator < (const TTimeStep &aTimeStep) const

{
    if (TimeStep == aTimeStep.TimeStep)
        return SubTimeStep < aTimeStep.SubTimeStep;
    else
        return TimeStep < aTimeStep.TimeStep;
}

// ===================================================================================

inline bool
TTimeStep::operator > (const TTimeStep &aTimeStep) const

{
    if (TimeStep == aTimeStep.TimeStep)
        return SubTimeStep > aTimeStep.SubTimeStep;
    else
        return TimeStep > aTimeStep.TimeStep;
}

// ===================================================================================

inline long
TTimeStep::GetLinear(void) const

{
    return TimeStep * NrOfSubTimeSteps + SubTimeStep;
}

// ===================================================================================

inline int
TTimeStep::GetNrOfSubTimeSteps(void)

{
    return NrOfSubTimeSteps;
}

// ===================================================================================

inline int
TTimeStep::GetSubStep(void) const

{
    return SubTimeStep;
}

// =================================================================================== 

inline int
TTimeStep::Hours(void) const

{
    return TimeStep / 3600;
}

// =================================================================================== 

inline int
TTimeStep::Minutes(void) const

{
    return (TimeStep / 60) % 60;
}

// =================================================================================== 
