/*      file     : XTraffic/XGraphx.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: XGraphx.h,v 1.2 2005/03/25 17:01:28 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef XGRAPHX_H
#define XGRAPHX_H

// ***INCLUDES************************************************************************ 

#include <TLocation.h>
#include <Graphx.h>

// ***CLASSES************************************************************************* 

class GrLocLine : public GrLine

{
public:

    GrLocLine(const TLocation &From, const TLocation &To, int Color) :
        GrLine(From.x(), From.y(), To.x(), To.y(), Color) { ;};    
};

// ===================================================================================

class GrRectangle : public GrBox

{
public:

    GrRectangle(const TRectangle &Rect, int Color) :
        GrBox(Rect.GetMinX(), Rect.GetMinY(),
              Rect.GetMaxX(), Rect.GetMaxY(), Color) { ;};
};

// ===================================================================================

class GrLocPoint : public GrPoint

{
public:

    GrLocPoint(const TLocation &P, int Color) : GrPoint(P.x(), P.y(), Color) { ;}; 
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
